var fs = require('fs');
var lines = fs.readFileSync("COVERAGE.md", "utf8").split('\n').filter(function (l) { return /^\s*\- \[|^### /.test(l); });
var i = 0;
var stats = processLines(0);
printStats("Total", stats);
function printStats(title, stats) {
    console.log(title, Math.round(stats.total * 100) + "%");
    if (!stats.hasNested)
        return;
    for (var k in stats) {
        if (k != "total" && k != "hasNested")
            printStats(k, stats[k]);
    }
}
function processLines(indent) {
    var implemented = 0;
    var total = 0;
    var stats = {};
    while (i < lines.length) {
        var spaces = lines[i].match(/^\s*/)[0];
        if (spaces.length < indent)
            break;
        total += 1;
        if (lines[i + 1] && lines[i + 1].startsWith(spaces + " ")) {
            var title = lines[i];
            i++;
            var lineStats = processLines(spaces.length + 1);
            implemented += lineStats.total;
            stats[title] = lineStats;
            stats["hasNested"] = true;
        }
        else if (lines[i].startsWith(spaces + "- [x]")) {
            var progress = lines[i].endsWith(")_") ? 0.5 : 1;
            stats[lines[i]] = { total: progress };
            implemented += progress;
            i++;
        }
        else {
            stats[lines[i]] = { total: 0 };
            i++;
        }
    }
    stats["total"] = implemented / total;
    return stats;
}
//# sourceMappingURL=calc_conformance.js.map