"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
var template_1 = require("../template");
var variable_1 = require("./variable");
var CFunctionPrototype = /** @class */ (function () {
    function CFunctionPrototype(scope, node) {
        this.parameters = [];
        this.returnType = scope.root.typeHelper.getTypeString(node);
        this.name = node.name.getText();
        this.parameters = node.parameters.map(function (p) { return new variable_1.CVariable(scope, p.name.getText(), p.name, { removeStorageSpecifier: true }); });
    }
    CFunctionPrototype = __decorate([
        template_1.CodeTemplate("{returnType} {name}({parameters {, }=> {this}});")
    ], CFunctionPrototype);
    return CFunctionPrototype;
}());
exports.CFunctionPrototype = CFunctionPrototype;
var CFunction = /** @class */ (function () {
    function CFunction(root, node) {
        var _this = this;
        this.root = root;
        this.func = this;
        this.parameters = [];
        this.variables = [];
        this.statements = [];
        this.parent = root;
        this.name = node.name.getText();
        var funcType = root.typeHelper.getCType(node);
        this.funcDecl = new variable_1.CVariable(root, this.name, funcType.returnType, { removeStorageSpecifier: true });
        this.parameters = node.parameters.map(function (p) {
            return new variable_1.CVariable(_this, p.name.text, p.name, { removeStorageSpecifier: true });
        });
        if (funcType.instanceType)
            this.parameters.unshift(new variable_1.CVariable(this, "this", funcType.instanceType, { removeStorageSpecifier: true }));
        this.variables = [];
        this.gcVarNames = root.memoryManager.getGCVariablesForScope(node);
        var _loop_1 = function (gcVarName) {
            if (root.variables.filter(function (v) { return v.name == gcVarName; }).length)
                return "continue";
            var gcType = gcVarName.indexOf("arrays") == -1 ? "ARRAY(void *)" : "ARRAY(ARRAY(void *))";
            root.variables.push(new variable_1.CVariable(root, gcVarName, gcType));
        };
        for (var _i = 0, _a = this.gcVarNames; _i < _a.length; _i++) {
            var gcVarName = _a[_i];
            _loop_1(gcVarName);
        }
        node.body.statements.forEach(function (s) { return _this.statements.push(template_1.CodeTemplateFactory.createForNode(_this, s)); });
        if (node.body.statements[node.body.statements.length - 1].kind != ts.SyntaxKind.ReturnStatement) {
            this.destructors = new variable_1.CVariableDestructors(this, node);
        }
    }
    CFunction = __decorate([
        template_1.CodeTemplate("\n{funcDecl}({parameters {, }=> {this}})\n{\n    {variables  {    }=> {this};\n}\n    {gcVarNames {    }=> ARRAY_CREATE({this}, 2, 0);\n}\n\n    {statements {    }=> {this}}\n\n    {destructors}\n}", ts.SyntaxKind.FunctionDeclaration)
    ], CFunction);
    return CFunction;
}());
exports.CFunction = CFunction;
var CFunctionExpression = /** @class */ (function () {
    function CFunctionExpression(scope, expression) {
        var dynamicFunction = new CFunction(scope.root, expression);
        scope.root.functions.push(dynamicFunction);
        this.name = dynamicFunction.name;
    }
    CFunctionExpression = __decorate([
        template_1.CodeTemplate("{name}", ts.SyntaxKind.FunctionExpression)
    ], CFunctionExpression);
    return CFunctionExpression;
}());
exports.CFunctionExpression = CFunctionExpression;
//# sourceMappingURL=function.js.map