"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("../types");
var template_1 = require("../template");
var typeguards_1 = require("../typeguards");
var elementaccess_1 = require("./elementaccess");
var variable_1 = require("./variable");
var CAsUniversalVar = /** @class */ (function () {
    function CAsUniversalVar(scope, expr, type) {
        this.expression = typeguards_1.isNode(expr) ? template_1.CodeTemplateFactory.createForNode(scope, expr) : expr;
        type = type || typeguards_1.isNode(expr) && scope.root.typeHelper.getCType(expr);
        this.isUniversalVar = type === types_1.UniversalVarType;
        this.isString = type === types_1.StringVarType;
        this.isNumber = type === types_1.NumberVarType;
        this.isBoolean = type === types_1.BooleanVarType;
        this.isArray = type instanceof types_1.ArrayType;
        this.isDict = type instanceof types_1.StructType || type instanceof types_1.DictType;
        if (type === types_1.StringVarType)
            scope.root.headerFlags.js_var_from_str = true;
        if (type === types_1.NumberVarType)
            scope.root.headerFlags.js_var_from_int16_t = true;
        if (type === types_1.BooleanVarType)
            scope.root.headerFlags.js_var_from_uint8_t = true;
        if (type instanceof types_1.ArrayType)
            scope.root.headerFlags.js_var_array = true;
        if (type instanceof types_1.StructType || type instanceof types_1.DictType)
            scope.root.headerFlags.js_var_dict = true;
        scope.root.headerFlags.js_var = true;
    }
    CAsUniversalVar = __decorate([
        template_1.CodeTemplate("\n{#if isUniversalVar}\n    {expression}\n{#elseif isString}\n    js_var_from_str({expression})\n{#elseif isNumber}\n    js_var_from_int16_t({expression})\n{#elseif isBoolean}\n    js_var_from_uint8_t({expression})\n{#elseif isArray}\n    js_var_from_array({expression})\n{#elseif isDict}\n    js_var_from_dict({expression})\n{#else}\n    /** converting {expression} to js_var is not supported yet */\n{/if}")
    ], CAsUniversalVar);
    return CAsUniversalVar;
}());
exports.CAsUniversalVar = CAsUniversalVar;
var CAsNumber = /** @class */ (function () {
    function CAsNumber(scope, expr, type) {
        this.type = type;
        this.isSingleElementStaticArray = false;
        this.expression = typeguards_1.isNode(expr) ? template_1.CodeTemplateFactory.createForNode(scope, expr) : expr;
        type = type || typeguards_1.isNode(expr) && scope.root.typeHelper.getCType(expr);
        this.isNumber = type === types_1.NumberVarType;
        this.isString = type === types_1.StringVarType;
        this.isBoolean = type === types_1.BooleanVarType;
        this.isUniversalVar = type === types_1.UniversalVarType;
        if (type instanceof types_1.ArrayType && !type.isDynamicArray && type.capacity === 1) {
            this.isSingleElementStaticArray = true;
            this.arrayFirstElementAsNumber = new CAsNumber_1(scope, new elementaccess_1.CSimpleElementAccess(scope, type, this.expression, "0"), type.elementType);
        }
    }
    CAsNumber_1 = CAsNumber;
    CAsNumber = CAsNumber_1 = __decorate([
        template_1.CodeTemplate("\n{#if isNumber || isBoolean}\n    {expression}\n{#elseif isString}\n    str_to_int16_t({expression})\n{#elseif isUniversalVar}\n    js_var_to_number({expression})\n{#elseif isSingleElementStaticArray}\n    {arrayFirstElementAsNumber}\n{#else}\n    js_var_from(JS_VAR_NAN)\n{/if}")
    ], CAsNumber);
    return CAsNumber;
    var CAsNumber_1;
}());
exports.CAsNumber = CAsNumber;
var CAsString_Length = /** @class */ (function () {
    function CAsString_Length(scope, node, arg, type) {
        var _this = this;
        this.arg = arg;
        this.type = type;
        this.isNumber = type === types_1.NumberVarType;
        this.isString = type === types_1.StringVarType;
        this.isBoolean = type === types_1.BooleanVarType;
        this.isArrayOfString = type instanceof types_1.ArrayType && type.elementType === types_1.StringVarType;
        this.isArrayOfNumber = type instanceof types_1.ArrayType && type.elementType === types_1.NumberVarType;
        this.isArrayOfBoolean = type instanceof types_1.ArrayType && type.elementType === types_1.BooleanVarType;
        this.isArrayOfUniversalVar = type instanceof types_1.ArrayType && type.elementType === types_1.UniversalVarType;
        this.isArrayOfArray = type instanceof types_1.ArrayType && type.elementType instanceof Array;
        this.isArrayOfObj = type instanceof types_1.ArrayType && (type.elementType instanceof types_1.DictType || type.elementType instanceof types_1.StructType);
        this.arraySize = type instanceof types_1.ArrayType && new elementaccess_1.CArraySize(scope, arg, type);
        if (this.isArrayOfString || this.isArrayOfUniversalVar) {
            this.iteratorVarName = scope.root.symbolsHelper.addIterator(node);
            scope.variables.push(new variable_1.CVariable(scope, this.iteratorVarName, types_1.NumberVarType));
            this.arrayElement = new elementaccess_1.CSimpleElementAccess(scope, type, arg, this.iteratorVarName);
            this.lengthVarName = scope.root.symbolsHelper.addTemp(node, "len");
            scope.variables.push(new variable_1.CVariable(scope, this.lengthVarName, types_1.NumberVarType));
            scope.root.headerFlags.strings = true;
        }
        if (this.isArrayOfUniversalVar) {
            this.tmpVarName = scope.root.symbolsHelper.addTemp(node, "tmp", false);
            this.needDisposeVarName = scope.root.symbolsHelper.addTemp(node, "need_dispose", false);
            if (!scope.variables.some(function (v) { return v.name == _this.tmpVarName; }))
                scope.variables.push(new variable_1.CVariable(scope, this.tmpVarName, types_1.StringVarType));
            if (!scope.variables.some(function (v) { return v.name == _this.needDisposeVarName; }))
                scope.variables.push(new variable_1.CVariable(scope, this.needDisposeVarName, types_1.BooleanVarType));
            scope.root.headerFlags.js_var_to_str = true;
        }
    }
    CAsString_Length = __decorate([
        template_1.CodeTemplate("\n{#statements}\n    {#if isArrayOfString}\n        {lengthVarName} = {arraySize};\n        for ({iteratorVarName} = 0; {iteratorVarName} < {arraySize}; {iteratorVarName}++)\n            {lengthVarName} += strlen({arrayElement});\n    {#elseif isArrayOfUniversalVar}\n        {lengthVarName} = {arraySize};\n        for ({iteratorVarName} = 0; {iteratorVarName} < {arraySize}; {iteratorVarName}++) {\n            {lengthVarName} += strlen({tmpVarName} = js_var_to_str({arrayElement}, &{needDisposeVarName}));\n            if ({needDisposeVarName})\n                free((void *){tmpVarName});\n        }\n    {/if}\n{/statements}\n{#if isNumber}\n    STR_INT16_T_BUFLEN\n{#elseif isString}\n    strlen({arg})\n{#elseif isBoolean}\n    (5-{arg})\n{#elseif isArrayOfNumber}\n    (STR_INT16_T_BUFLEN + 1) * {arraySize}\n{#elseif isArrayOfBoolean}\n    6 * {arraySize}\n{#elseif isArrayOfObj}\n    16 * {arraySize}\n{#elseif isArrayOfString || isArrayOfUniversalVar}\n    {lengthVarName}\n{#elseif isArrayOfArray}\n    /* determining string length of array {arg} is not supported yet */\n{#else}\n    15\n{/if}")
    ], CAsString_Length);
    return CAsString_Length;
}());
exports.CAsString_Length = CAsString_Length;
var CAsString_Concat = /** @class */ (function () {
    function CAsString_Concat(scope, node, buf, arg, type) {
        var _this = this;
        this.buf = buf;
        this.arg = arg;
        this.type = type;
        this.isArray = false;
        this.isNumber = type === types_1.NumberVarType;
        this.isString = type === types_1.StringVarType;
        this.isBoolean = type === types_1.BooleanVarType;
        this.isUniversalVar = type === types_1.UniversalVarType;
        if (this.isUniversalVar) {
            this.tmpVarName = scope.root.symbolsHelper.addTemp(node, "tmp", false);
            this.needDisposeVarName = scope.root.symbolsHelper.addTemp(node, "need_dispose", false);
            if (!scope.variables.some(function (v) { return v.name == _this.tmpVarName; }))
                scope.variables.push(new variable_1.CVariable(scope, this.tmpVarName, types_1.StringVarType));
            if (!scope.variables.some(function (v) { return v.name == _this.needDisposeVarName; }))
                scope.variables.push(new variable_1.CVariable(scope, this.needDisposeVarName, types_1.BooleanVarType));
            scope.root.headerFlags.js_var_to_str = true;
        }
        if (type instanceof types_1.ArrayType) {
            this.isArray = true;
            this.iteratorVarName = scope.root.symbolsHelper.addIterator(node);
            scope.variables.push(new variable_1.CVariable(scope, this.iteratorVarName, types_1.NumberVarType));
            var arrayElement = new elementaccess_1.CSimpleElementAccess(scope, type, arg, this.iteratorVarName);
            this.arrayElementCat = new CAsString_Concat_1(scope, node, buf, arrayElement, type.elementType);
            this.arraySize = new elementaccess_1.CArraySize(scope, arg, type);
        }
    }
    CAsString_Concat_1 = CAsString_Concat;
    CAsString_Concat = CAsString_Concat_1 = __decorate([
        template_1.CodeTemplate("\n{#if isNumber}\n    str_int16_t_cat({buf}, {arg});\n{#elseif isString}\n    strcat({buf}, {arg});\n{#elseif isBoolean}\n    strcat({buf}, {arg} ? \"true\" : \"false\");\n{#elseif isUniversalVar}\n    strcat({buf}, ({tmpVarName} = js_var_to_str({arg}, &{needDisposeVarName})));\n    if ({needDisposeVarName})\n        free((void *){tmpVarName});\n{#elseif isArray}\n    for ({iteratorVarName} = 0; {iteratorVarName} < {arraySize}; {iteratorVarName}++) {\n        if ({iteratorVarName} != 0)\n            strcat({buf}, \",\");\n        {arrayElementCat}\n    }\n{#else}\n    strcat({buf}, \"[object Object]\");\n{/if}\n")
    ], CAsString_Concat);
    return CAsString_Concat;
    var CAsString_Concat_1;
}());
exports.CAsString_Concat = CAsString_Concat;
//# sourceMappingURL=typeconvert.js.map