"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
var template_1 = require("../../template");
var standard_1 = require("../../standard");
var types_1 = require("../../types");
var NumberCallResolver = /** @class */ (function () {
    function NumberCallResolver() {
    }
    NumberCallResolver.prototype.matchesNode = function (typeHelper, call) {
        return ts.isIdentifier(call.expression) && call.expression.text == "Number";
    };
    NumberCallResolver.prototype.returnType = function (typeHelper, call) {
        var type = typeHelper.getCType(call.arguments[0]);
        return type == types_1.NumberVarType ? types_1.NumberVarType : types_1.UniversalVarType;
    };
    NumberCallResolver.prototype.createTemplate = function (scope, node) {
        return new CNumberCall(scope, node);
    };
    NumberCallResolver.prototype.needsDisposal = function (typeHelper, node) {
        return false;
    };
    NumberCallResolver.prototype.getTempVarName = function (typeHelper, node) {
        return null;
    };
    NumberCallResolver.prototype.getEscapeNode = function (typeHelper, node) {
        return null;
    };
    NumberCallResolver = __decorate([
        standard_1.StandardCallResolver
    ], NumberCallResolver);
    return NumberCallResolver;
}());
var CNumberCall = /** @class */ (function () {
    function CNumberCall(scope, call) {
        this.call = "";
        this.arg = template_1.CodeTemplateFactory.createForNode(scope, call.arguments[0]);
        var type = scope.root.typeHelper.getCType(call.arguments[0]);
        if (type != types_1.NumberVarType && type != types_1.UniversalVarType) {
            this.call = "str_to_int16_t";
            scope.root.headerFlags.str_to_int16_t = true;
        }
        else if (type == types_1.UniversalVarType) {
            this.call = "js_var_to_number";
            scope.root.headerFlags.js_var_to_number = true;
        }
    }
    CNumberCall = __decorate([
        template_1.CodeTemplate("\n{#if call}\n    {call}({arg})\n{#else}\n    {arg}\n{/if}")
    ], CNumberCall);
    return CNumberCall;
}());
//# sourceMappingURL=number.js.map