"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
var template_1 = require("../../template");
var standard_1 = require("../../standard");
var types_1 = require("../../types");
var elementaccess_1 = require("../../nodes/elementaccess");
var StringIndexOfResolver = /** @class */ (function () {
    function StringIndexOfResolver() {
    }
    StringIndexOfResolver.prototype.matchesNode = function (typeHelper, call) {
        if (call.expression.kind != ts.SyntaxKind.PropertyAccessExpression)
            return false;
        var propAccess = call.expression;
        var objType = typeHelper.getCType(propAccess.expression);
        return propAccess.name.getText() == "indexOf" && objType == types_1.StringVarType;
    };
    StringIndexOfResolver.prototype.returnType = function (typeHelper, call) {
        return types_1.NumberVarType;
    };
    StringIndexOfResolver.prototype.createTemplate = function (scope, node) {
        return new CStringIndexOf(scope, node);
    };
    StringIndexOfResolver.prototype.needsDisposal = function (typeHelper, node) {
        return false;
    };
    StringIndexOfResolver.prototype.getTempVarName = function (typeHelper, node) {
        return null;
    };
    StringIndexOfResolver.prototype.getEscapeNode = function (typeHelper, node) {
        return null;
    };
    StringIndexOfResolver = __decorate([
        standard_1.StandardCallResolver
    ], StringIndexOfResolver);
    return StringIndexOfResolver;
}());
var CStringIndexOf = /** @class */ (function () {
    function CStringIndexOf(scope, call) {
        var propAccess = call.expression;
        this.topExpressionOfStatement = call.parent.kind == ts.SyntaxKind.ExpressionStatement;
        if (!this.topExpressionOfStatement) {
            if (call.arguments.length == 1) {
                this.stringAccess = new elementaccess_1.CElementAccess(scope, propAccess.expression);
                this.arg1 = template_1.CodeTemplateFactory.createForNode(scope, call.arguments[0]);
                scope.root.headerFlags.str_pos = true;
            }
            else
                console.log("Unsupported number of parameters in " + call.getText() + ". Expected one parameter.");
        }
    }
    CStringIndexOf = __decorate([
        template_1.CodeTemplate("\n{#if !topExpressionOfStatement}\n    str_pos({stringAccess}, {arg1})\n{/if}")
    ], CStringIndexOf);
    return CStringIndexOf;
}());
//# sourceMappingURL=indexOf.js.map